package Uploader::Preferences;
use strict;
use base qw/Uploader::Object/;
use Storable;


my @gui_properties = qw/
    wx_thumb_size
    wx_quality
    display_mode
/;


my @image_properties = qw/
    author
    hd_filter
    hd_blur
    hd_quality
    hd_w
    hd_h
    hd_interlace
    thumb_size
    resize_w
    resize_h
    type
    filter
    blur
    quality
    th_quality
    auto_rotate
    upload_hd
    remove_uploaded_from_selection
    interlace
    create_resized
    prefix
    default_caption_pattern
    default_caption
    watermark_activate
    watermark_activate_pwg_high
    watermark_text
    watermark_text_size
    watermark_position
    watermark_y
    watermark_x
    watermark_color
    reupload_action_files
    reupload_action_properties
    reupload_action_properties_m
    reupload_not_ask
    display_mode
    thumbnail_shape_square
    chunk_size
    default_openfile_dir
/;

__PACKAGE__->mk_accessors(@gui_properties);
__PACKAGE__->mk_accessors(@image_properties);


sub Init {
    my ( $self ) = @_;
}


sub Store {
    my ( $self ) = @_;
    
    my $data = $self->get_storable(
        [ 
            qw/
                version
                storable_file
            /,
            @gui_properties,
            @image_properties,
        ] 
    
    );
    eval {
        #print Dumper $data;
        store $data, $self->storable_file if defined $self->storable_file;
    };
    if($@){
        print $@, "\n";    
    }
}


sub get_data {
    my ( $self ) = @_;

    return {
        map { $_ => $self->$_ } @image_properties,
    }
}

1;